Summary:        ACPICA tools for the development and debug of ACPI tables
Name:           acpica-tools
Version:        20220331
Release:        4%{?dist}

License:        GPLv2
URL:            https://www.acpica.org/

Source0:        https://acpica.org/sites/acpica/files/acpica-unix2-%{version}.tar.gz
Source1:        https://acpica.org/sites/acpica/files/acpitests-unix-%{version}.tar.gz
Source3:        iasl.1
Source4:        acpibin.1
Source5:        acpidump.1
Source6:        acpiexec.1
Source7:        acpihelp.1
Source9:        acpisrc.1
Source10:       acpixtract.1
Source11:       badcode.asl.result
Source12:       grammar.asl.result
Source13:       converterSample.asl.result
Source14:       run-misc-tests.sh
Source15:       COPYING

Patch3000:	0001-Add-in-basic-infrastructure-for-big-endian-support.patch
Patch3001:	0002-Modify-utility-functions-to-be-endian-agnostic.patch
Patch3002:	0003-Always-display-table-header-content-in-human-readabl.patch
Patch3003:	0004-Re-enable-support-for-big-endian-machines.patch
Patch3004:	0005-Correct-an-endian-ness-problem-when-converting-ASL-t.patch
Patch3005:	0006-Use-more-reliable-ACPI_COPY_NAMSEG-in-GPE-name-check.patch
Patch3006:	0007-Handle-dumping-Unicode-properly-when-big-endian.patch
Patch3007:	0008-Support-MADT-aka-APIC-in-a-big-endian-world.patch
Patch3008:	0009-Support-ASF-tables-in-a-big-endian-world.patch
Patch3009:	0010-Support-CPEP-tables-in-a-big-endian-world.patch
Patch3010:	0011-Support-DBG2-table-in-a-big-endian-world.patch
Patch3011:	0012-Support-DMAR-in-a-big-endian-world.patch
Patch3012:	0013-Support-DRTM-in-a-big-endian-world.patch
Patch3013:	0014-Support-EINJ-in-a-big-endian-world.patch
Patch3014:	0015-Support-ERST-in-a-big-endian-world.patch
Patch3015:	0016-Support-FADT-aka-FACP-in-a-big-endian-world.patch
Patch3016:	0017-Support-most-FPDTs-in-a-big-endian-world.patch
Patch3017:	0018-Support-GTDT-in-a-big-endian-world.patch
Patch3018:	0019-Support-HEST-in-a-big-endian-world.patch
Patch3019:	0020-Support-RSDT-RSD-PTR-in-a-big-endian-world.patch
Patch3020:	0021-Support-XSDT-in-a-big-endian-world.patch
Patch3021:	0022-Support-SRAT-in-a-big-endian-world.patch
Patch3022:	0023-Support-SLIT-in-a-big-endian-world.patch
Patch3023:	0024-Support-MSCT-in-a-big-endian-world.patch
Patch3024:	0025-Support-MPST-in-a-big-endian-world.patch
Patch3025:	0026-Support-NFIT-in-a-big-endian-world.patch
Patch3026:	0027-Support-SDEV-in-a-big-endian-world.patch
Patch3027:	0028-Support-HMAT-in-a-big-endian-world.patch
Patch3028:	0029-Support-PDTT-in-a-big-endian-world.patch
Patch3029:	0030-Support-PPTT-in-a-big-endian-world.patch
Patch3030:	0031-Support-PCCT-in-a-big-endian-world.patch
Patch3031:	0032-Support-WDAT-in-a-big-endian-world.patch
Patch3032:	0033-Support-TCPA-in-a-big-endian-world.patch
Patch3033:	0034-Support-STAO-in-a-big-endian-world.patch
Patch3034:	0035-Support-SLIC-and-MSDM-in-a-big-endian-world.patch
Patch3035:	0036-Support-MCFG-in-a-big-endian-world.patch
Patch3036:	0037-Support-LPIT-in-a-big-endian-world.patch
Patch3037:	0038-Support-PMTT-in-a-big-endian-world.patch
Patch3038:	0039-Support-TPM2-in-a-big-endian-world.patch
Patch3039:	0040-Support-S3PT-in-a-big-endian-world.patch
Patch3040:	0041-Support-IORT-in-a-big-endian-world.patch
Patch3041:	0042-Support-IVRS-in-a-big-endian-world.patch
Patch3042:	0043-Support-DSDT-SSDT-in-a-big-endian-world.patch
Patch3043:	0045-CSRT-fixed-use-of-optional-ResourceInfo.patch
Patch3044:	0046-Support-PHAT-in-a-big-endian-world.patch
Patch3045:	0047-Support-PRMT-in-a-big-endian-world.patch
Patch3046:	0048-Support-RGRT-in-a-big-endian-world.patch
Patch3047:	0049-Support-SVKL-in-a-big-endian-world.patch

Patch3048:	unaligned.patch
Patch3049:	OPT_LDFLAGS.patch
Patch3050:	int-format.patch
Patch3051:	f23-harden.patch
Patch3052:	template.patch
Patch3053:      arm7hl.patch
Patch3054:      simple-64bit.patch
Patch3055:      mips-be-fix.patch
Patch3056:      cve-2017-13693.patch
Patch3057:      cve-2017-13694.patch
Patch3058:      cve-2017-13695.patch
Patch3059:      str-trunc-warn.patch
Patch3060:	ptr-cast.patch
Patch3061:	armv7-str-fixes.patch
Patch3062:	dbtest.patch
Patch3063:	ull-32bit.patch
Patch3064:	dangling-ptr.patch
Patch3065:	uuid-len.patch

BuildRequires:  bison patchutils flex gcc make

Provides:       acpixtract >= 20120913-7
Provides:       iasl = %{version}-%{release}
Provides:       acpidump >= 20100513-5
Provides:       pmtools = %{version}-%{release}

%description
The ACPI Component Architecture (ACPICA) project provides an OS-independent
reference implementation of the Advanced Configuration and Power Interface
Specification (ACPI).  ACPICA code contains those portions of ACPI meant to
be directly integrated into the host OS as a kernel-resident subsystem, and
a small set of tools to assist in developing and debugging ACPI tables.

This package contains only the user-space tools needed for ACPI table
development, not the kernel implementation of ACPI.  The following commands
are installed:
   -- iasl: compiles ASL (ACPI Source Language) into AML (ACPI Machine
      Language), suitable for inclusion as a DSDT in system firmware.
      It also can disassemble AML, for debugging purposes.
   -- acpibin: performs basic operations on binary AML files (e.g.,
      comparison, data extraction)
   -- acpidump: write out the current contents of ACPI tables
   -- acpiexec: simulate AML execution in order to debug method definitions
   -- acpihelp: display help messages describing ASL keywords and op-codes
   -- acpisrc: manipulate the ACPICA source tree and format source files
      for specific environments
   -- acpixtract: extract binary ACPI tables from acpidump output (see
      also the pmtools package)

This version of the tools is being released under GPLv2 license.

%prep
%setup -n acpica-unix2-%{version}
gzip -dc %{SOURCE1} | tar -x --strip-components=1 -f -

%autopatch -p1

cp -p %{SOURCE3} iasl.1
cp -p %{SOURCE4} acpibin.1
cp -p %{SOURCE5} acpidump.1
cp -p %{SOURCE6} acpiexec.1
cp -p %{SOURCE7} acpihelp.1
cp -p %{SOURCE9} acpisrc.1
cp -p %{SOURCE10} acpixtract.1
cp -p %{SOURCE11} badcode.asl.result
cp -p %{SOURCE12} grammar.asl.result
cp -p %{SOURCE13} converterSample.asl.result
cp -p %{SOURCE14} tests/run-misc-tests.sh
chmod a+x tests/run-misc-tests.sh
cp -p %{SOURCE15} COPYING

chmod a-x changes.txt
chmod a-x source/compiler/new_table.txt


%build
CWARNINGFLAGS="\
    -std=c99\
    -Wall\
    -Wbad-function-cast\
    -Wdeclaration-after-statement\
    -Werror\
    -Wformat=2\
    -Wmissing-declarations\
    -Wmissing-prototypes\
    -Wstrict-aliasing=0\
    -Wstrict-prototypes\
    -Wswitch-default\
    -Wpointer-arith\
    -Wundef\
    -Waddress\
    -Waggregate-return\
    -Winit-self\
    -Winline\
    -Wmissing-declarations\
    -Wmissing-field-initializers\
    -Wnested-externs\
    -Wold-style-definition\
    -Wno-format-nonliteral\
    -Wredundant-decls\
    -Wempty-body\
    -Woverride-init\
    -Wlogical-op\
    -Wmissing-parameter-type\
    -Wold-style-declaration\
    -Wtype-limits"

OPT_CFLAGS="%{optflags} $CWARNINGFLAGS"
OPT_LDFLAGS="%{__global_ldflags}"
export OPT_CFLAGS
export OPT_LDFLAGS

%make_build


%install
mkdir -p %{buildroot}%{_bindir}
install -pD generate/unix/bin*/* %{buildroot}%{_bindir}/

mkdir -p %{buildroot}%{_mandir}/man1
install -pDm 0644 *.1 %{buildroot}%{_mandir}/man1/


%check
cd tests

./aslts.sh
[ $? -eq 0 ] || exit 1

./run-misc-tests.sh %{buildroot}%{_bindir} %{version}

%pre
if [ -e %{_bindir}/acpixtract-acpica ]
then
    alternatives --remove acpixtract %{_bindir}/acpixtract-acpica
fi
if [ -e %{_bindir}/acpidump-acpica ]
then
    alternatives --remove acpidump %{_bindir}/acpidump-acpica
fi

%postun
if [ -e %{_bindir}/acpixtract-acpica ]
then
    alternatives --remove acpixtract %{_bindir}/acpixtract-acpica
fi
if [ -e %{_bindir}/acpidump-acpica ]
then
    alternatives --remove acpidump %{_bindir}/acpidump-acpica
fi


%files
%license COPYING
%doc changes.txt source/compiler/new_table.txt
%{_bindir}/*
%{_mandir}/*/*


%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 20220331-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 20220331-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 20220331-2
- Rebuilt for OpenCloudOS Stream 23

* Wed Nov 16 2022 cunshunxia <cunshunxia@tencent.com> - 20220331-1
- initial build
